commit c896828577d907de109f9b99842656c39f704915
Author: jklowden <jklowden>
Date:   Sat Feb 7 00:26:22 2009 +0000

    better winsock initialization and dbdatecrack

diff --git a/ChangeLog b/ChangeLog
index de609a5..bbeb142 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Fri Feb  6 19:22:16 EST 2009	JK Lowden <jklowden@freetds.org>
+	* include/sybdb.h include/tds.h src/dblib/dblib.c 
+	* src/tds/convert.c src/tds/mem.c src/tds/net.c
+	- better winsock initialization and dbdatecrack
+
 Fri Feb  6 15:25:10 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* misc/freetds_autobuild: remove openjade warning
 	* src/tds/unittests/convert.c: make valgrind happy
@@ -1290,4 +1295,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2724 2009/02/06 14:26:54 freddy77 Exp $
+$Id: ChangeLog,v 1.2725 2009/02/07 00:26:22 jklowden Exp $
diff --git a/include/sybdb.h b/include/sybdb.h
index f2b7d04..866a5d5 100644
--- a/include/sybdb.h
+++ b/include/sybdb.h
@@ -41,7 +41,7 @@ extern "C"
 #define TDS_STATIC_CAST(type, a) ((type)(a))
 #endif
 
-static const char rcsid_sybdb_h[] = "$Id: sybdb.h,v 1.87 2009/01/31 19:13:20 jklowden Exp $";
+static const char rcsid_sybdb_h[] = "$Id: sybdb.h,v 1.88 2009/02/07 00:26:22 jklowden Exp $";
 static const void *const no_unused_sybdb_h_warn[] = { rcsid_sybdb_h, no_unused_sybdb_h_warn };
 
 #ifdef FALSE
@@ -370,32 +370,52 @@ typedef struct
 
 typedef struct tds_dblib_dbprocess DBPROCESS;
 
-typedef struct dbdaterec
+/*
+ * Sybase & Microsoft use different names for the dbdaterec members. 
+ * Keep these two structures physically identical in memory.  
+ * dbdatecrack() casts one to the other for ease of implementation. 
+ * N.B. Microsoft documents the members as int, not long.   
+ *
+ * Giving credit where credit is due, we can acknowledge that
+ * Microsoft chose the better names here, hands down.  ("datedmonth"?!)
+ */
+struct tds_microsoft_dbdaterec
+{
+	long year;		/* 1753 - 9999  	   */
+	long quarter;		/* 1 - 4 		   */
+	long month;		/* 1 - 12 		   */
+	long day;		/* 1 - 31 		   */
+	long dayofyear;		/* 1 - 366 		   */
+	long week;            	/* 1 - 54 (for leap years) */
+	long weekday;		/* 1 - 7 (Mon. - Sun.)     */
+	long hour;		/* 0 - 23 		   */
+	long minute;		/* 0 - 59 		   */
+	long second;		/* 0 - 59 		   */
+	long millisecond;	/* 0 - 999 		   */
+	long tzone;		/* 0 - 127  (Sybase only)  */	
+};					
+
+struct tds_sybase_dbdaterec
 {
+	long dateyear;		/* 1900 and counting	  */ 
+	long quarter;		/* 0 - 3 (Microsoft only) */
+	long datemonth;		/* 0 - 11   	     	  */
+	long datedmonth;	/* 1 - 31   	     	  */
+	long datedyear;		/* 1 - 366  	     	  */
+	long week;            	/* 1 - 54 (Microsoft only) */
+	long datedweek;		/* 0 - 6    	     	  */
+	long datehour; 		/* 0 - 23   	     	  */
+	long dateminute;	/* 0 - 59   	     	  */
+	long datesecond;	/* 0 - 59   	     	  */
+	long datemsecond;	/* 0 - 997  	     	  */
+	long datetzone;		/* 0 - 127  	     	  */
+};
+
 #ifdef MSDBLIB
-	DBINT year;
-	DBINT month;
-	DBINT day;
-	DBINT dayofyear;
-	DBINT weekday;
-	DBINT hour;
-	DBINT minute;
-	DBINT second;
-	DBINT millisecond;
-	DBINT tzone;
+typedef struct tds_microsoft_dbdaterec DBDATEREC;
 #else
-	DBINT dateyear;
-	DBINT datemonth;
-	DBINT datedmonth;
-	DBINT datedyear;
-	DBINT datedweek;
-	DBINT datehour;
-	DBINT dateminute;
-	DBINT datesecond;
-	DBINT datemsecond;
-	DBINT datetzone;
+typedef struct tds_sybase_dbdaterec DBDATEREC;
 #endif
-} DBDATEREC;
 
 typedef int (*EHANDLEFUNC) (DBPROCESS * dbproc, int severity, int dberr, int oserr, char *dberrstr, char *oserrstr);
 
diff --git a/include/tds.h b/include/tds.h
index bf61881..1ae3dea 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.310 2009/01/16 20:27:57 jklowden Exp $ */
+/* $Id: tds.h,v 1.311 2009/02/07 00:26:22 jklowden Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -173,9 +173,11 @@ typedef struct tdsunique
 typedef struct tdsdaterec
 {
 	TDS_INT year;	       /**< year */
+	TDS_INT quarter;       /**< quarter (0-3) */
 	TDS_INT month;	       /**< month number (0-11) */
 	TDS_INT day;	       /**< day of month (1-31) */
 	TDS_INT dayofyear;     /**< day of year  (1-366) */
+	TDS_INT week;          /**< 1 - 54 (can be 54 in leap year) */
 	TDS_INT weekday;       /**< day of week  (0-6, 0 = sunday) */
 	TDS_INT hour;	       /**< 0-23 */
 	TDS_INT minute;	       /**< 0-59 */
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index a846159..db40841 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -62,7 +62,6 @@
  * 	This affects how certain application-addressable 
  * 	strucures are defined.  
  */
-#define SYBDBLIB 1
 #include <tds.h>
 #include <tdsthread.h>
 #include <tdsconvert.h>
@@ -76,7 +75,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.340 2009/01/31 19:13:20 jklowden Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.341 2009/02/07 00:26:22 jklowden Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -1836,7 +1835,6 @@ RETCODE
 dbsetnull(DBPROCESS * dbproc, int bindtype, int bindlen, BYTE *bindval)
 {
 	BYTE *pval;
-	size_t len;
 	
 	tdsdump_log(TDS_DBG_FUNC, "dbsetnull(%p, %d, %d, %p)\n", dbproc, bindtype, bindlen, bindval);
 	
@@ -1856,22 +1854,21 @@ dbsetnull(DBPROCESS * dbproc, int bindtype, int bindlen, BYTE *bindval)
 	case SMALLDATETIMEBIND:
 	case SMALLMONEYBIND:
 	case TINYBIND:
-		len = default_null_representations[bindtype].len;
+		bindlen = (int)default_null_representations[bindtype].len;
 		break;
 
 	case CHARBIND:
 	case BINARYBIND:
 		CHECK_PARAMETER(bindlen >= 0, SYBEBBL, FAIL);
-		len = bindlen;
 		break;
 		
-	case NTBSTRINGBIND:	len = strlen((char *) bindval);
+	case NTBSTRINGBIND:	bindlen = (int)strlen((char *) bindval);
 		break;
-	case STRINGBIND:	len = strlen((char *) bindval);
+	case STRINGBIND:	bindlen = (int)strlen((char *) bindval);
 		break;
-	case VARYBINBIND:	len = ((TDS_VARBINARY*) bindval)->len;
+	case VARYBINBIND:	bindlen = ((TDS_VARBINARY*) bindval)->len;
 		break;
-	case VARYCHARBIND:	len = ((TDS_VARCHAR*) bindval)->len;
+	case VARYCHARBIND:	bindlen = ((TDS_VARCHAR*) bindval)->len;
 		break;
 
 #if 0
@@ -1883,7 +1880,7 @@ dbsetnull(DBPROCESS * dbproc, int bindtype, int bindlen, BYTE *bindval)
 		return FAIL;
 	}
 
-	if ((pval = malloc(len)) == NULL) {
+	if ((pval = malloc(bindlen)) == NULL) {
 		dbperror(dbproc, SYBEMEM, errno);
 		return FAIL;
 	}
@@ -1892,12 +1889,12 @@ dbsetnull(DBPROCESS * dbproc, int bindtype, int bindlen, BYTE *bindval)
 	if (dbproc->nullreps[bindtype].bindval != default_null_representations[bindtype].bindval)
 		free((BYTE*)dbproc->nullreps[bindtype].bindval);
 
-	memcpy(pval, bindval, len);
+	memcpy(pval, bindval, bindlen);
 	
 	dbproc->nullreps[bindtype].bindval = pval;
-	dbproc->nullreps[bindtype].len = len;
+	dbproc->nullreps[bindtype].len = bindlen;
 
-	tdsdump_dump_buf(TDS_DBG_NETWORK, "null representation set ", pval,  len);
+	tdsdump_dump_buf(TDS_DBG_NETWORK, "null representation set ", pval,  bindlen);
 	return SUCCEED;
 }
 
@@ -5531,19 +5528,24 @@ dbdatecmp(DBPROCESS * dbproc, DBDATETIME * d1, DBDATETIME * d2)
  * \sa dbconvert(), dbdata(), dbdatechar(), dbdatename(), dbdatepart().
  */
 RETCODE
-dbdatecrack(DBPROCESS * dbproc, DBDATEREC * di, DBDATETIME * datetime)
+dbdatecrack(DBPROCESS * dbproc, DBDATEREC * output, DBDATETIME * datetime)
 {
+#if MSDBLIB
+	const int msdblib = 1;
+#else
+	const int msdblib = 0;
+#endif
 	TDSDATEREC dr;
+	struct tds_sybase_dbdaterec *di = (struct tds_sybase_dbdaterec*) output;
 
-	tdsdump_log(TDS_DBG_FUNC, "dbdatecrack(%p, %p, %p)\n", dbproc, di, datetime);
-	CHECK_DBPROC();
-	DBPERROR_RETURN(IS_TDSDEAD(dbproc->tds_socket), SYBEDDNE);
-	CHECK_NULP(di, "dbdatecrack", 2, FAIL);
+	tdsdump_log(TDS_DBG_FUNC, "dbdatecrack(%p, %p, %p)\n", dbproc, output, datetime);
+	CHECK_NULP(output, "dbdatecrack", 2, FAIL);
 	CHECK_PARAMETER(datetime, SYBENDTP, FAIL);
 
 	tds_datecrack(SYBDATETIME, datetime, &dr);
 
 	di->dateyear = dr.year;
+	di->quarter = dr.quarter;
 	di->datemonth = dr.month;
 	di->datedmonth = dr.day;
 	di->datedyear = dr.dayofyear;
@@ -5552,7 +5554,9 @@ dbdatecrack(DBPROCESS * dbproc, DBDATEREC * di, DBDATETIME * datetime)
 	di->dateminute = dr.minute;
 	di->datesecond = dr.second;
 	di->datemsecond = dr.millisecond;
-	if (dbproc->msdblib) {
+	/* Revert to compiled-in default if dbproc can't be used to find the runtime override. */
+	if( dbproc && dbproc->msdblib || msdblib && !dbproc  ) {
+		++di->quarter;
 		++di->datemonth;
 		++di->datedweek;
 	}
diff --git a/src/tds/convert.c b/src/tds/convert.c
index 5810975..32dc709 100644
--- a/src/tds/convert.c
+++ b/src/tds/convert.c
@@ -64,7 +64,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert.c,v 1.187 2009/01/16 20:27:58 jklowden Exp $");
+TDS_RCSID(var, "$Id: convert.c,v 1.188 2009/02/07 00:26:22 jklowden Exp $");
 
 typedef unsigned short utf16_t;
 
@@ -2877,6 +2877,42 @@ tds_willconvert(int srctype, int desttype)
 #endif
 }
 
+#if 0
+select day(d) as day, datepart(dw, d) as weekday, datepart(week, d) as week, d as 'date' from #t order by d
+day         weekday     week        date                                                   
+----------- ----------- ----------- ----------
+          1           5           1 2009-01-01 Thursday
+          2           6           1 2009-01-02 Friday
+          3           7           1 2009-01-03 Saturday
+          4           1           2 2009-01-04 Sunday
+          5           2           2 2009-01-05
+          6           3           2 2009-01-06
+          7           4           2 2009-01-07
+          8           5           2 2009-01-08
+          9           6           2 2009-01-09
+         10           7           2 2009-01-10
+         11           1           3 2009-01-11
+         12           2           3 2009-01-12
+         13           3           3 2009-01-13
+         14           4           3 2009-01-14
+         15           5           3 2009-01-15
+         16           6           3 2009-01-16
+         17           7           3 2009-01-17
+         18           1           4 2009-01-18
+         19           2           4 2009-01-19
+         20           3           4 2009-01-20
+         21           4           4 2009-01-21
+         22           5           4 2009-01-22
+         23           6           4 2009-01-23
+         24           7           4 2009-01-24
+         25           1           5 2009-01-25
+         26           2           5 2009-01-26
+         27           3           5 2009-01-27
+         28           4           5 2009-01-28
+         29           5           5 2009-01-29
+         30           6           5 2009-01-30
+         31           7           5 2009-01-31
+#endif
 /**
  * Convert from db date format to a structured date format
  * @param datetype source date type. SYBDATETIME or SYBDATETIME4
@@ -2939,8 +2975,10 @@ tds_datecrack(TDS_INT datetype, const void *di, TDSDATEREC * dr)
 
 	dr->year = years;
 	dr->month = months;
+	dr->quarter = months / 3;
 	dr->day = days;
 	dr->dayofyear = ydays;
+	dr->week = -1;
 	dr->weekday = wday;
 	dr->hour = hours;
 	dr->minute = mins;
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 218ecfd..33d6e99 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.187 2009/01/23 10:42:25 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.188 2009/02/07 00:26:22 jklowden Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -616,23 +616,27 @@ tds_free_all_results(TDSSOCKET * tds)
 /*
  * Return 1 if winsock is initialized, else 0.
  */
+const char *tds_prwsaerror( int erc );
 static int
 winsock_initialized(void)
 {
 #if defined(_WIN32) || defined(_WIN64)
 	WSADATA wsa_data;
 	int erc;
-	DWORD how_much = 0;
+	WSAPROTOCOL_INFO protocols[8];
+	DWORD how_much = sizeof(protocols);
 	WORD requested_version = MAKEWORD(2, 2);
-
-	if (SOCKET_ERROR != WSAEnumProtocols(NULL, NULL, &how_much))
+	 
+	if (SOCKET_ERROR != WSAEnumProtocols(NULL, protocols, &how_much)) 
 		return 1;
 
-	if (WSANOTINITIALISED != WSAGetLastError())
+	if (WSANOTINITIALISED != (erc = WSAGetLastError())) {
+		fprintf(stderr, "tds_init_winsock: WSAEnumProtocols failed with %d(%s)\n", erc, tds_prwsaerror(erc) ); 
 		return 0;
-
+	}
+	
 	if (SOCKET_ERROR == (erc = WSAStartup(requested_version, &wsa_data))) {
-		fprintf(stderr, "tds_init_winsock: WSAStartup failed with %d(%s)\n", erc, WSAGetLastError() );
+		fprintf(stderr, "tds_init_winsock: WSAStartup failed with %d(%s)\n", erc, tds_prwsaerror(erc) ); 
 		return 0;
 	}
 #endif
diff --git a/src/tds/net.c b/src/tds/net.c
index 7b5a63a..5fd6ebb 100644
--- a/src/tds/net.c
+++ b/src/tds/net.c
@@ -103,7 +103,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: net.c,v 1.85 2009/01/16 20:27:58 jklowden Exp $");
+TDS_RCSID(var, "$Id: net.c,v 1.86 2009/02/07 00:26:22 jklowden Exp $");
 
 #undef USE_POLL
 #if defined(HAVE_POLL_H) && defined(HAVE_POLL)
@@ -1130,6 +1130,128 @@ tds7_get_instance_port(const char *ip_addr, const char *instance)
 	return port;
 }
 
+#if defined(_WIN32)
+const char *
+tds_prwsaerror( int erc ) 
+{
+	switch(erc) {
+	case WSAEINTR: /* 10004 */
+		return "WSAEINTR: Interrupted function call.";
+	case WSAEACCES: /* 10013 */
+		return "WSAEACCES: Permission denied.";
+	case WSAEFAULT: /* 10014 */
+		return "WSAEFAULT: Bad address.";
+	case WSAEINVAL: /* 10022 */
+		return "WSAEINVAL: Invalid argument.";
+	case WSAEMFILE: /* 10024 */
+		return "WSAEMFILE: Too many open files.";
+	case WSAEWOULDBLOCK: /* 10035 */
+		return "WSAEWOULDBLOCK: Resource temporarily unavailable.";
+	case WSAEINPROGRESS: /* 10036 */
+		return "WSAEINPROGRESS: Operation now in progress.";
+	case WSAEALREADY: /* 10037 */
+		return "WSAEALREADY: Operation already in progress.";
+	case WSAENOTSOCK: /* 10038 */
+		return "WSAENOTSOCK: Socket operation on nonsocket.";
+	case WSAEDESTADDRREQ: /* 10039 */
+		return "WSAEDESTADDRREQ: Destination address required.";
+	case WSAEMSGSIZE: /* 10040 */
+		return "WSAEMSGSIZE: Message too long.";
+	case WSAEPROTOTYPE: /* 10041 */
+		return "WSAEPROTOTYPE: Protocol wrong type for socket.";
+	case WSAENOPROTOOPT: /* 10042 */
+		return "WSAENOPROTOOPT: Bad protocol option.";
+	case WSAEPROTONOSUPPORT: /* 10043 */
+		return "WSAEPROTONOSUPPORT: Protocol not supported.";
+	case WSAESOCKTNOSUPPORT: /* 10044 */
+		return "WSAESOCKTNOSUPPORT: Socket type not supported.";
+	case WSAEOPNOTSUPP: /* 10045 */
+		return "WSAEOPNOTSUPP: Operation not supported.";
+	case WSAEPFNOSUPPORT: /* 10046 */
+		return "WSAEPFNOSUPPORT: Protocol family not supported.";
+	case WSAEAFNOSUPPORT: /* 10047 */
+		return "WSAEAFNOSUPPORT: Address family not supported by protocol family.";
+	case WSAEADDRINUSE: /* 10048 */
+		return "WSAEADDRINUSE: Address already in use.";
+	case WSAEADDRNOTAVAIL: /* 10049 */
+		return "WSAEADDRNOTAVAIL: Cannot assign requested address.";
+	case WSAENETDOWN: /* 10050 */
+		return "WSAENETDOWN: Network is down.";
+	case WSAENETUNREACH: /* 10051 */
+		return "WSAENETUNREACH: Network is unreachable.";
+	case WSAENETRESET: /* 10052 */
+		return "WSAENETRESET: Network dropped connection on reset.";
+	case WSAECONNABORTED: /* 10053 */
+		return "WSAECONNABORTED: Software caused connection abort.";
+	case WSAECONNRESET: /* 10054 */
+		return "WSAECONNRESET: Connection reset by peer.";
+	case WSAENOBUFS: /* 10055 */
+		return "WSAENOBUFS: No buffer space available.";
+	case WSAEISCONN: /* 10056 */
+		return "WSAEISCONN: Socket is already connected.";
+	case WSAENOTCONN: /* 10057 */
+		return "WSAENOTCONN: Socket is not connected.";
+	case WSAESHUTDOWN: /* 10058 */
+		return "WSAESHUTDOWN: Cannot send after socket shutdown.";
+	case WSAETIMEDOUT: /* 10060 */
+		return "WSAETIMEDOUT: Connection timed out.";
+	case WSAECONNREFUSED: /* 10061 */
+		return "WSAECONNREFUSED: Connection refused.";
+	case WSAEHOSTDOWN: /* 10064 */
+		return "WSAEHOSTDOWN: Host is down.";
+	case WSAEHOSTUNREACH: /* 10065 */
+		return "WSAEHOSTUNREACH: No route to host.";
+	case WSAEPROCLIM: /* 10067 */
+		return "WSAEPROCLIM: Too many processes.";
+	case WSASYSNOTREADY: /* 10091 */
+		return "WSASYSNOTREADY: Network subsystem is unavailable.";
+	case WSAVERNOTSUPPORTED: /* 10092 */
+		return "WSAVERNOTSUPPORTED: Winsock.dll version out of range.";
+	case WSANOTINITIALISED: /* 10093 */
+		return "WSANOTINITIALISED: Successful WSAStartup not yet performed.";
+	case WSAEDISCON: /* 10101 */
+		return "WSAEDISCON: Graceful shutdown in progress.";
+	case WSATYPE_NOT_FOUND: /* 10109 */
+		return "WSATYPE_NOT_FOUND: Class type not found.";
+	case WSAHOST_NOT_FOUND: /* 11001 */
+		return "WSAHOST_NOT_FOUND: Host not found.";
+	case WSATRY_AGAIN: /* 11002 */
+		return "WSATRY_AGAIN: Nonauthoritative host not found.";
+	case WSANO_RECOVERY: /* 11003 */
+		return "WSANO_RECOVERY: This is a nonrecoverable error.";
+	case WSANO_DATA: /* 11004 */
+		return "WSANO_DATA: Valid name, no data record of requested type.";
+	case WSA_INVALID_HANDLE: /* OS dependent */
+		return "WSA_INVALID_HANDLE: Specified event object handle is invalid.";
+	case WSA_INVALID_PARAMETER: /* OS dependent */
+		return "WSA_INVALID_PARAMETER: One or more parameters are invalid.";
+	case WSA_IO_INCOMPLETE: /* OS dependent */
+		return "WSA_IO_INCOMPLETE: Overlapped I/O event object not in signaled state.";
+	case WSA_IO_PENDING: /* OS dependent */
+		return "WSA_IO_PENDING: Overlapped operations will complete later.";
+	case WSA_NOT_ENOUGH_MEMORY: /* OS dependent */
+		return "WSA_NOT_ENOUGH_MEMORY: Insufficient memory available.";
+	case WSA_OPERATION_ABORTED: /* OS dependent */
+		return "WSA_OPERATION_ABORTED: Overlapped operation aborted.";
+#if defined(WSAINVALIDPROCTABLE)
+	case WSAINVALIDPROCTABLE: /* OS dependent */
+		return "WSAINVALIDPROCTABLE: Invalid procedure table from service provider.";
+#endif
+#if defined(WSAINVALIDPROVIDER)
+	case WSAINVALIDPROVIDER: /* OS dependent */
+		return "WSAINVALIDPROVIDER: Invalid service provider version number.";
+#endif
+#if defined(WSAPROVIDERFAILEDINIT)
+	case WSAPROVIDERFAILEDINIT: /* OS dependent */
+		return "WSAPROVIDERFAILEDINIT: Unable to initialize a service provider.";
+#endif
+	case WSASYSCALLFAILURE: /* OS dependent */
+		return "WSASYSCALLFAILURE: System call failure.";
+	}
+	return "undocumented WSA error code";
+}
+#endif
+
 #if defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 
 #ifdef HAVE_GNUTLS

